Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/HeuristicLabAlgorithmsDataAnalysisViewsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/HeuristicLabAlgorithmsDataAnalysisViewsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/HeuristicLabAlgorithmsDataAnalysisViewsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.DataAnalysis.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.DataAnalysis.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.DataAnalysis.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.DataAnalysis.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Algorithms.DataAnalysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis.Views/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.3/HeuristicLabAlgorithmsDataAnalysisPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.3/HeuristicLabAlgorithmsDataAnalysisPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.3/HeuristicLabAlgorithmsDataAnalysisPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.DataAnalysis plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.DataAnalysis", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.DataAnalysis", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.DataAnalysis-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/CrossValidation.cs	(revision 6195)
@@ -373,7 +373,35 @@
       foreach (IResult result in ExtractAndAggregateResults<PercentValue>(resultCollections))
         results.Add(result.Name, result.Value);
-
+      foreach (IResult result in ExtractAndAggregateRegressionSolutions(resultCollections)) {
+        results.Add(result.Name, result.Value);
+      }
       results.Add("Execution Time", new TimeSpanValue(this.ExecutionTime));
       results.Add("CrossValidation Folds", new RunCollection(runs));
+    }
+
+    private IEnumerable<IResult> ExtractAndAggregateRegressionSolutions(IEnumerable<KeyValuePair<string, IItem>> resultCollections) {
+      Dictionary<string, List<IRegressionSolution>> resultSolutions = new Dictionary<string, List<IRegressionSolution>>();
+      foreach (var result in resultCollections) {
+        var regressionSolution = result.Value as IRegressionSolution;
+        if (regressionSolution != null) {
+          if (resultSolutions.ContainsKey(result.Key)) {
+            resultSolutions[result.Key].Add(regressionSolution);
+          } else {
+            resultSolutions.Add(result.Key, new List<IRegressionSolution>() { regressionSolution });
+          }
+        }
+      }
+      List<IResult> aggregatedResults = new List<IResult>();
+      foreach (KeyValuePair<string, List<IRegressionSolution>> solutions in resultSolutions) {
+        var problemDataClone = (IRegressionProblemData)Problem.ProblemData.Clone();
+        problemDataClone.TrainingPartition.Start = SamplesStart.Value; problemDataClone.TrainingPartition.End = SamplesEnd.Value;
+        problemDataClone.TestPartition.Start = SamplesStart.Value; problemDataClone.TestPartition.End = SamplesEnd.Value;
+        var ensembleSolution = new RegressionEnsembleSolution(solutions.Value.Select(x => x.Model), problemDataClone,
+          solutions.Value.Select(x => x.ProblemData.TrainingPartition),
+          solutions.Value.Select(x => x.ProblemData.TestPartition));
+
+        aggregatedResults.Add(new Result(solutions.Key, ensembleSolution));
+      }
+      return aggregatedResults;
     }
 
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs	(revision 6195)
@@ -68,7 +68,5 @@
       string targetVariable = problemData.TargetVariable;
       IEnumerable<string> allowedInputVariables = problemData.AllowedInputVariables;
-      int samplesStart = problemData.TrainingPartition.Start;
-      int samplesEnd = problemData.TrainingPartition.End;
-      IEnumerable<int> rows = Enumerable.Range(samplesStart, samplesEnd - samplesStart);
+      IEnumerable<int> rows = problemData.TrainingIndizes;
       int nClasses = problemData.ClassNames.Count();
       double[,] inputMatrix = AlglibUtil.PrepareInputMatrix(dataset, allowedInputVariables.Concat(new string[] { targetVariable }), rows);
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 6195)
@@ -72,7 +72,5 @@
       string targetVariable = problemData.TargetVariable;
       IEnumerable<string> allowedInputVariables = problemData.AllowedInputVariables;
-      int samplesStart = problemData.TrainingPartition.Start;
-      int samplesEnd = problemData.TrainingPartition.End;
-      IEnumerable<int> rows = Enumerable.Range(samplesStart, samplesEnd - samplesStart);
+      IEnumerable<int> rows = problemData.TrainingIndizes;
       double[,] inputMatrix = AlglibUtil.PrepareInputMatrix(dataset, allowedInputVariables.Concat(new string[] { targetVariable }), rows);
       if (inputMatrix.Cast<double>().Any(x => double.IsNaN(x) || double.IsInfinity(x)))
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorClassification.cs
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorClassification.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorClassification.cs	(revision 6195)
@@ -122,7 +122,5 @@
       Dataset dataset = problemData.Dataset;
       string targetVariable = problemData.TargetVariable;
-      int start = problemData.TrainingPartition.Start;
-      int end = problemData.TrainingPartition.End;
-      IEnumerable<int> rows = Enumerable.Range(start, end - start);
+      IEnumerable<int> rows = problemData.TrainingIndizes;
 
       //extract SVM parameters from scope and set them
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorRegression.cs
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorRegression.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/SupportVectorMachine/SupportVectorRegression.cs	(revision 6195)
@@ -130,7 +130,5 @@
       Dataset dataset = problemData.Dataset;
       string targetVariable = problemData.TargetVariable;
-      int start = problemData.TrainingPartition.Start;
-      int end = problemData.TrainingPartition.End;
-      IEnumerable<int> rows = Enumerable.Range(start, end - start);
+      IEnumerable<int> rows = problemData.TrainingIndizes;
 
       //extract SVM parameters from scope and set them
Index: branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/kMeans/KMeansClustering.cs
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/kMeans/KMeansClustering.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.DataAnalysis/3.4/kMeans/KMeansClustering.cs	(revision 6195)
@@ -85,7 +85,5 @@
       Dataset dataset = problemData.Dataset;
       IEnumerable<string> allowedInputVariables = problemData.AllowedInputVariables;
-      int start = problemData.TrainingPartition.Start;
-      int end = problemData.TrainingPartition.End;
-      IEnumerable<int> rows = Enumerable.Range(start, end - start);
+      IEnumerable<int> rows = problemData.TrainingIndizes;
       int info;
       double[,] centers;
Index: branches/histogram/HeuristicLab.Algorithms.EvolutionStrategy/3.3/HeuristicLabAlgorithmsEvolutionStrategyPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.EvolutionStrategy/3.3/HeuristicLabAlgorithmsEvolutionStrategyPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.EvolutionStrategy/3.3/HeuristicLabAlgorithmsEvolutionStrategyPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.EvolutionStrategy plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.EvolutionStrategy", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.EvolutionStrategy", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.EvolutionStrategy-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.EvolutionStrategy/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/HeuristicLabAlgorithmsGeneticAlgorithmPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/HeuristicLabAlgorithmsGeneticAlgorithmPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/HeuristicLabAlgorithmsGeneticAlgorithmPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.GeneticAlgorithm plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.GeneticAlgorithm", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.GeneticAlgorithm", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.GeneticAlgorithm-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.LocalSearch/3.3/HeuristicLabAlgorithmsLocalSearchPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.LocalSearch/3.3/HeuristicLabAlgorithmsLocalSearchPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.LocalSearch/3.3/HeuristicLabAlgorithmsLocalSearchPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.LocalSearch plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.LocalSearch", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.LocalSearch", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.LocalSearch-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.LocalSearch/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.LocalSearch/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.LocalSearch/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.NSGA2/3.3/HeuristicLabAlgorithmsNSGA2Plugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.NSGA2/3.3/HeuristicLabAlgorithmsNSGA2Plugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.NSGA2/3.3/HeuristicLabAlgorithmsNSGA2Plugin.cs.frame	(revision 6195)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Algorithms.NSGA2 {
-  [Plugin("HeuristicLab.Algorithms.NSGA2", "Provides the non-dominated sorting genetic algorithm (NSGA-II) as described in Deb et al. 2002. A Fast and Elitist Multiobjective Genetic Algorithm: NSGA-II. IEEE Transactions on Evolutionary Computation, 6(2), pp. 182-197.", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.NSGA2", "Provides the non-dominated sorting genetic algorithm (NSGA-II) as described in Deb et al. 2002. A Fast and Elitist Multiobjective Genetic Algorithm: NSGA-II. IEEE Transactions on Evolutionary Computation, 6(2), pp. 182-197.", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.NSGA2-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.NSGA2/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.NSGA2/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.NSGA2/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -34,3 +34,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/HeuristicLabAlgorithmsOffspringSelectionGeneticAlgorithmPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/HeuristicLabAlgorithmsOffspringSelectionGeneticAlgorithmPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/HeuristicLabAlgorithmsOffspringSelectionGeneticAlgorithmPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLabAlgorithmsParticleSwarmOptimizationPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLabAlgorithmsParticleSwarmOptimizationPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/HeuristicLabAlgorithmsParticleSwarmOptimizationPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.ParticleSwarmOptimization plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.ParticleSwarmOptimization", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.ParticleSwarmOptimization", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/HeuristicLabAlgorithmsSimulatedAnnealingPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/HeuristicLabAlgorithmsSimulatedAnnealingPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/HeuristicLabAlgorithmsSimulatedAnnealingPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.SimulatedAnnealing plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.SimulatedAnnealing", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.SimulatedAnnealing", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.SimulatedAnnealing-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.TabuSearch/3.3/HeuristicLabAlgorithmsTabuSearchPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.TabuSearch/3.3/HeuristicLabAlgorithmsTabuSearchPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.TabuSearch/3.3/HeuristicLabAlgorithmsTabuSearchPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.TabuSearch plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.TabuSearch", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.TabuSearch", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.TabuSearch-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Algorithms.TabuSearch/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.TabuSearch/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.TabuSearch/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/HeuristicLabAlgorithmsVariableNeighborhoodSearchPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/HeuristicLabAlgorithmsVariableNeighborhoodSearchPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/HeuristicLabAlgorithmsVariableNeighborhoodSearchPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Algorithms.VariableNeighborhoodSearch plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Algorithms.VariableNeighborhoodSearch", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Algorithms.VariableNeighborhoodSearch", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Algorithms.VariableNeighborhoodSearch-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]  
Index: branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -53,3 +53,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearch.cs
===================================================================
--- branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearch.cs	(revision 6194)
+++ branches/histogram/HeuristicLab.Algorithms.VariableNeighborhoodSearch/3.3/VariableNeighborhoodSearch.cs	(revision 6195)
@@ -35,5 +35,5 @@
 
 namespace HeuristicLab.Algorithms.VariableNeighborhoodSearch {
-  [Item("Variable Neighborhood Search", "A variable neighborhood search algorithm.")]
+  [Item("Variable Neighborhood Search", "A variable neighborhood search algorithm based on the description in Mladenovic, N. and Hansen, P. (1997). Variable neighborhood search. Computers & Operations Research Volume 24, Issue 11, pp. 1097-1100.")]
   [Creatable("Algorithms")]
   [StorableClass]
@@ -166,4 +166,14 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
+      if (Parameters["LocalImprovement"] is ValueParameter<ILocalImprovementOperator>) {
+        ILocalImprovementOperator bla = ((ValueParameter<ILocalImprovementOperator>)Parameters["LocalImprovement"]).Value;
+        Parameters.Remove("LocalImprovement");
+        Parameters.Add(new ConstrainedValueParameter<ILocalImprovementOperator>("LocalImprovement", "The local improvement operation"));
+        LocalImprovementParameter.ValidValues.Add(bla);
+        IMultiNeighborhoodShakingOperator bla2 = ((ValueParameter<IMultiNeighborhoodShakingOperator>)Parameters["Shaking"]).Value;
+        Parameters.Remove("Shaking");
+        Parameters.Add(new ConstrainedValueParameter<IMultiNeighborhoodShakingOperator>("ShakingOperator", "The operator that performs the shaking of solutions."));
+        ShakingOperatorParameter.ValidValues.Add(bla2);
+      }
       RegisterEventHandlers();
     }
Index: branches/histogram/HeuristicLab.Analysis.Views/3.3/HeuristicLabAnalysisViewsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Analysis.Views/3.3/HeuristicLabAnalysisViewsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Analysis.Views/3.3/HeuristicLabAnalysisViewsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Analysis.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Analysis.Views", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Analysis.Views", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Analysis.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Analysis", "3.3")]
Index: branches/histogram/HeuristicLab.Analysis.Views/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Analysis.Views/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Analysis.Views/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLabAnalysisPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLabAnalysisPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Analysis/3.3/HeuristicLabAnalysisPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Analysis plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Analysis", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Analysis", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Analysis-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.ALGLIB", "3.1")]
Index: branches/histogram/HeuristicLab.Analysis/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Analysis/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Analysis/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Clients.Common/3.3/HeuristicLabClientsCommonPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Clients.Common/3.3/HeuristicLabClientsCommonPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Clients.Common/3.3/HeuristicLabClientsCommonPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Clients.Common plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Clients.Common", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Clients.Common", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Clients.Common-3.3.dll", PluginFileType.Assembly)]
   public class HeuristicLabClientsCommonPlugin : PluginBase {
Index: branches/histogram/HeuristicLab.Clients.Common/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Clients.Common/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Clients.Common/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -55,3 +55,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.CodeEditor/3.3/HeuristicLabCodeEditorPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.CodeEditor/3.3/HeuristicLabCodeEditorPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.CodeEditor/3.3/HeuristicLabCodeEditorPlugin.cs.frame	(revision 6195)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.CodeEditor {
-  [Plugin("HeuristicLab.CodeEditor", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.CodeEditor", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.CodeEditor-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
Index: branches/histogram/HeuristicLab.CodeEditor/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.CodeEditor/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.CodeEditor/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -51,3 +51,3 @@
 //
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
Index: branches/histogram/HeuristicLab.Collections/3.3/HeuristicLabCollectionsPlugin.cs.frame
===================================================================
--- branches/histogram/HeuristicLab.Collections/3.3/HeuristicLabCollectionsPlugin.cs.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Collections/3.3/HeuristicLabCollectionsPlugin.cs.frame	(revision 6195)
@@ -26,5 +26,5 @@
   /// Plugin class for HeuristicLab.Collections plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Collections", "3.3.3.$WCREV$")]
+  [Plugin("HeuristicLab.Collections", "3.3.4.$WCREV$")]
   [PluginFile("HeuristicLab.Collections-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
Index: branches/histogram/HeuristicLab.Collections/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/histogram/HeuristicLab.Collections/3.3/Properties/AssemblyInfo.frame	(revision 6194)
+++ branches/histogram/HeuristicLab.Collections/3.3/Properties/AssemblyInfo.frame	(revision 6195)
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.3.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.4.$WCREV$")]
